<template>
  <div class="quiz-ads-section">
    <!-- <main-header></main-header> -->

    <div class="content-section position-relative">
      <img src="@/assets/img/game_overlay.png" class="bg position-absolute w-100 top-0 start-0" />
      <div class="container py-5">
        <div class="row">
          <div class="col col-12 d-flex justify-content-center flex-column align-items-center mb-5">
            <h2 class="text-white fw-bold">TODAY'S 1 MINUTE QUIZ</h2>
            <p class="text-white">Join in and get free coin now!</p>
          </div>
        </div>
        <div class="row">
          <div class="col col-12 col-lg-4 mb-5 mb-lg-0">
            <custom-today-reward></custom-today-reward>
          </div>
          <div class="col col-12 col-lg-8 order-lg-first">
            <div class="row position-relative" style="overflow: hidden; z-index: 9">
              <div class="col ads-frame position-relative p-0">
                <div class="bg-danger w-100" v-if="!loadVideo"></div>
                <!-- <div v-if="adsEmbedId" class="w-100" id="player-placeholder">
                  <youtube
                    :video-id="adsEmbedId"
                    ref="youtube"
                    @ready="playVideo"
                    @playing="startTimeOut"
                    height="400"
                    width="100%"
                  ></youtube>
                </div> -->
                <video
                  v-if="loadVideo && !isMobile()"
                  src="../assets/img/ads_video.mp4"
                  style="
                    z-index: -1;
                    object-fit: contain;
                    width: 100%;
                    border-radius: 22px;
                  "
                  playsinline
                  loop
                  muted
                  autoplay
                  controls
                  id="ads-video"
                  @click="unmuteVideo($event)"
                  @play="startTimeOut"
                >
                </video>
                <video
                  v-else-if="loadVideo && isMobile()"
                  src="../assets/img/ads_video.mp4"
                  style="
                    z-index: -1;
                    object-fit: cover;
                    width: 100vw;
                    height: 100vh;
                  "
                  playsinline
                  loop
                  muted
                  autoplay
                  controls
                  class="position-fixed top-0 start-0"
                  id="ads-video"
                  @click="unmuteVideo($event)"
                  @play="startTimeOut"
                >
                </video>
              </div>
              <div
                class="action-text position-absolute d-flex justify-content-end align-items-center px-0"
                style="top: 20px"
              >
                <!-- <p
                  class="back-text fw-bold text-light d-flex align-items-center pe-2 pe-lg-5 ps-3"
                  style="background: #0007; height: 42px; cursor: pointer;"
                  @click="$router.back()"
                >
                  Back
                </p> -->
                <p
                  class="timing-text fw-bold text-light d-flex align-items-center pe-3 ps-2 ps-lg-5"
                  style="background: #0005; height: 42px"
                >
                  Starting in<span class="ms-1 skiptranslate"> {{ timeOut }}</span>
                  s...
                </p>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- <main-footer></main-footer> -->

    <audio src="@/assets/audio/countdown.mp3" id="countdown-audio"></audio>

    <!-- Overlay -->
    <div
      class="frame-bofore-game position-fixed w-100 top-0 start-0 d-flex align-items-center justify-content-center"
      :class="{ 'show-frame': showBeforeGame }"
      style="height: 100%; background: #0005"
    >
      <h1 v-if="showBeforeGame" class="text-danger fw-bolder skiptranslate" style="font-size: 9rem">
        {{ timeBeforeGameDisplay }}
      </h1>
    </div>
  </div>
</template>

<script>
// import { getIdFromUrl } from "vue-youtube";
import CustomTodayReward from "../components/play-quiz-survey/CustomTodayReward.vue";
// import { apiCustomerGet } from "../services/baseApi.js";
// import embedYt from "../helper/embedYt.js";

export default {
  components: {
    CustomTodayReward
  },
  data() {
    return {
      timeOut: 15,
      timeBeforeGame: 3,
      adsEmbedId: "",
      idTimeOut: "",
      idTimeOutBefore: "",
      showBeforeGame: false,
      loadVideo: false
    };
  },
  computed: {
    player() {
      return this.$refs.youtube.player;
    },
    timeBeforeGameDisplay() {
      if (this.timeBeforeGame > 0) return this.timeBeforeGame;

      return "GO!";
    }
  },
  methods: {
    isMobile() {
      if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        return true;
      }
    },
    playVideo() {
      this.$refs.youtube.player.playVideo();
    },
    unmuteVideo(e) {
      let el = e.target;

      el.muted = !el.muted;
      console.log("runnn event");
    },
    // async setUpAds() {
    //   try {
    //     // Call service get Ads
    //     let res = await apiCustomerGet("ads/random");
    //     if (res && res.data && res.data.status) {
    //       let url = res.data.data.link;
    //       // let duration = res.data.data.duration || 15;

    //       // this.timeOut = duration;
    //       // this.adsEmbedId = getIdFromUrl(url);
    //     }
    //   } catch (error) {
    //     console.log(error);
    //   }
    // },
    startTimeOut() {
      let video = document.getElementById("ads-video");
      // video.muted = !video.muted;
      video.click();

      const countdown = setInterval(() => {
        if (this.timeOut === 0) {
          clearInterval(countdown);

          setTimeout(() => {
            document.getElementById("countdown-audio").play();

            this.showBeforeGame = true;
            this.startTimeBeforeGame();
          }, 1500);
          return;
        }

        this.timeOut -= 1;
      }, 1000);
      this.idTimeOut = countdown;
    },
    startTimeBeforeGame() {
      this.idTimeOutBefore = setInterval(() => {
        if (this.timeBeforeGame === 0) {
          clearInterval(this.idTimeOutBefore);

          this.$router.push("/quiz-play").catch(() => {});
          return;
        }

        this.timeBeforeGame -= 1;
      }, 1000);
    }
  },
  mounted() {
    // this.setUpAds();

    let adsVideo = document.getElementById("ads-video");
    let adsSection = document.getElementsByClassName("ads-frame")[0];
    let body = document.getElementsByTagName("body")[0];

    setTimeout(() => {
      body.style.height = "100vh";
      body.style.overflow = "hidden";

      if (!this.isMobile()) {
        adsSection.scrollIntoView({ block: "center" });
      }
      this.loadVideo = true;
      setTimeout(() => {
        adsVideo.play();
      }, 0);
    }, 1000);
  },
  beforeDestroy() {
    let body = document.getElementsByTagName("body")[0];

    body.style.height = "";
    body.style.overflow = "";

    clearInterval(this.idTimeOut);
    clearInterval(this.idTimeOutBefore);
  }
};
</script>

<style scoped>
.content-section img {
  height: 100%;
  object-fit: cover;
  z-index: -1;
}
.ads-frame > div {
  height: 400px;
  border-radius: 22px;
  overflow: hidden !important;
}
.show-frame {
  z-index: 999;
  background: #000a !important;
}
</style>
